package com.wall.proshot.wallpapers.myacctivity

import android.content.Intent
import android.os.Bundle
import android.view.View
import android.view.inputmethod.EditorInfo
import android.view.inputmethod.InputMethodManager
import android.widget.TextView.OnEditorActionListener
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity
import androidx.recyclerview.widget.GridLayoutManager
import com.wall.proshot.wallpapers.R
import com.wall.proshot.wallpapers.bean.Data
import com.wall.proshot.wallpapers.myconnector.OnItemClick
import com.wall.proshot.wallpapers.databinding.ActivityMySearchBinding
import com.wall.proshot.wallpapers.myitem.MyItemList
import com.wall.proshot.wallpapers.mytool.MyComUtils
import com.wall.proshot.wallpapers.mytool.MyItemHelper
import com.wall.proshot.wallpapers.mytool.MyObectBoxManager

class SearchActivity : AppCompatActivity() ,
    OnItemClick {
    private lateinit var adapterWallapper: MyItemList
    private lateinit var binding:ActivityMySearchBinding
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        binding = ActivityMySearchBinding.inflate(layoutInflater)
        setContentView(binding.root)
        MyComUtils.initFull(this, false)
        initList()
        binding.imageviewBack.setOnClickListener {
            finish()
        }
    }


    private fun initList() {
        val height = MyComUtils.dp2Px(180)
        adapterWallapper =
            MyItemList(this, height, true)
        adapterWallapper.setInfoWallpaperListener(this)
        val recyclerMyItemHelper = MyItemHelper(10, 10, 15)
        val gridLayoutManager = GridLayoutManager(this, 2)
        binding.resultRecycler.run {
            layoutManager = gridLayoutManager
            addItemDecoration(recyclerMyItemHelper)
            adapter = adapterWallapper
        }

        binding.et.setOnEditorActionListener(OnEditorActionListener { v, actionId, event ->
            if (actionId == EditorInfo.IME_ACTION_SEARCH) {
                startSearch()
                return@OnEditorActionListener true
            }
            false
        })
        binding.btnSearch.setOnClickListener { startSearch() }
    }

    private fun closeKeyboard() {
        val imm =  getSystemService(INPUT_METHOD_SERVICE) as InputMethodManager
        imm.hideSoftInputFromWindow(binding.et.windowToken, 0)
    }

    private fun startSearch() {
        closeKeyboard()
        binding.searchPb.visibility = View.VISIBLE
        val string: String = binding.et.text.toString()
        if (string.isNotEmpty()) {
            val search = MyObectBoxManager.search(string)
            if (search.size > 0) {
                showEmpty(false)
                adapterWallapper.setDataInfo(search)
                binding.searchPb.visibility = View.GONE
            } else {
                binding.searchPb.visibility = View.GONE
                showEmpty(true)
            }

        } else {
            binding.searchPb.visibility = View.GONE
            Toast.makeText(
                this,
                getString(R.string.please_input_keyword),
                Toast.LENGTH_SHORT
            ).show()
        }
    }

    private fun showEmpty(showEmpty: Boolean) {
        if (showEmpty) {
            binding.emptyLayout.visibility = View.VISIBLE
            binding.resultRecycler.visibility = View.GONE
        } else {
            binding.emptyLayout.visibility = View.GONE
            binding.resultRecycler.visibility = View.VISIBLE
        }
    }

    override fun onItemClickAction(info: Data?) {
        val intent = Intent(this, WallPaperActivity::class.java)
        intent.putExtra(MyComUtils.key_info, info)
        startActivity(intent)
    }
}